Subject: Re: [RFC PATCH 00/13] hardware time stamping + igb example implementation

From: Oliver Hartkopp <[email-masked]>
Date: Wed, 12 Nov 2008 23:26:35 +0100

Andi Kleen wrote:
> Eric Dumazet wrote:
>
>> This scheme only is needed for special devices, 
>
> It's going to be supported by a large range of mass market NICs,
> not special devices.
>
> used by PTP.

HW Timestamps are also state-of-the-art in a large range of Controller 
Area Network (CAN) NICs.
And when you want to write 'really professional' traffic sniffers or you 
need to deal with sensor fusion, hw timestamps allow big improvements in 
reliability of the sensor information.

>
>> TCP trafic wont use hwtstamp. 
>
> Actually it wouldn't surprise me if one of the numerous
> TCP congestion avoidance algorithms that get added all the time
> starts making use of such an enhanced time stamp.
>

I would also assume that people will find new use-cases for hw 
timestamps once they are available.

>> I threw a "crazy idea", that can be changed if necessary, say with a 
>> cookie
>> that identifies the slot in NIC driver structure. O(1) lookup if 
>> really needed.
>
> I think "crazy" describes it well because it would be a lot of dubious
> and likely not performing well effort just to save 8 bytes.
>

The crazy idea from Eric looks easier and more clearly to me than the 
discussed patch set from Patrick Ohly - but i wonder if we should give a 
separate hw timestamp a try ...

I know Patrick is not a friend of a CONFIG option here. But when we make 
it right HW timestamp could only be disabled on CONFIG_EMBEDDED or 
something like that.

Regards,
Oliver

> BTW it wouldn't surprise me if skb heads had some free space in common
> situations anyways becaus it's unlikely it fits exactly into 4K pages
> in slab/slub.
>
> -Andi